import Device from '@uci/i2c-device'
// import Device from '../../uci-i2c-device/src/device-packet'
import { pin, chip } from './commands'

import logger from '@uci/logger'
let log = {}

export default class MCP230XX extends Device {
  constructor(opts) {
    super(opts)
    log = logger({file:'src/mcp230xx.js',class:'MCP230XX',name:'mcp',id:this.id})
    this.chip17 = opts.chip17
    this.pin = this.bindFuncs(pin)
    this.chip = this.bindFuncs(chip)
  }

  async init(){
    await super.init()
    let res = await this.chip.cfg({})
    let cfg = this.chip17 ?'10100010':'00100010'
    if (res.response !==cfg ) throw `could not configure mcp chip at ${this.address}=0x${this.address.toString(16)}`
  }

} // end of MCP230XX Class
